package mrtjp.projectred.core;

import net.minecraft.init.Blocks;
import net.minecraft.block.Block;
import net.minecraft.world.World;
import net.minecraftforge.common.util.ForgeDirection;

public class BasicWireUtils
{
    public static boolean canPlaceWireOnSide(World w, int x, int y, int z, ForgeDirection side, boolean _default)
    {
        if (!w.blockExists(x, y, z))
            return _default;

        Block b = w.getBlock(x, y, z);
        if (b == null)
            return false;
        // Manual list of allowed blocks that wire can sit on.
        if (b == Blocks.glowstone || b == Blocks.piston || b == Blocks.sticky_piston || b == Blocks.piston_extension)
            return true;
        return b.isSideSolid(w, x, y, z, side);
    }

    public static boolean canPlaceTorchOnBlock(World w, int x, int y, int z, boolean _default)
    {
        if (!w.blockExists(x, y, z))
            return _default;

        Block b = w.getBlock(x, y, z);
        if (b == null)
            return false;

        return b.canPlaceTorchOnTop(w, x, y, z);
    }
}
