package mrtjp.projectred.core;

import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;

public abstract class ItemCraftingDamage extends ItemCore
{
    public ItemCraftingDamage(String name)
    {
        super(name);
        setMaxStackSize(1);
        setNoRepair();
    }

    @Override
    public abstract void registerIcons(IIconRegister par1IconRegister);

    @Override
    public boolean hasContainerItem()
    {
        return true;
    }

    @Override
    public ItemStack getContainerItem(ItemStack stack)
    {
        if (stack.getItem() == this)
        {
            stack.setItemDamage(stack.getItemDamage() + 1);
            return stack;
        }
        else
        {
            ItemStack newStack = new ItemStack(this);
            newStack.setItemDamage(newStack.getMaxDamage());
            return newStack;
        }
    }

    @Override
    public boolean doesContainerItemLeaveCraftingGrid(ItemStack is)
    {
        return false;
    }
}
