package mrtjp.projectred.exploration;

import mrtjp.projectred.ProjectRedExploration;
import mrtjp.projectred.core.ItemPart.EnumPart;
import net.minecraft.init.Blocks;
import net.minecraft.block.Block;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.Item.ToolMaterial;
import net.minecraft.item.ItemStack;

public enum EnumSpecialTool
{
    RUBYAXE("Ruby Axe", "axeruby", ProjectRedExploration.toolMaterialRuby(), EnumPart.RUBY.getItemStack()),
    SAPPHIREAXE("Sapphire Axe", "axesapphire", ProjectRedExploration.toolMaterialSapphire(), EnumPart.SAPPHIRE.getItemStack()),
    PERIDOTAXE("Peridot Axe", "axeperidot", ProjectRedExploration.toolMaterialPeridot(), EnumPart.PERIDOT.getItemStack()),

    RUBYPICKAXE("Ruby Pickaxe", "pickaxeruby", ProjectRedExploration.toolMaterialRuby(), EnumPart.RUBY.getItemStack()),
    SAPPHIREPICKAXE("Sapphire Pickaxe", "pickaxesapphire", ProjectRedExploration.toolMaterialSapphire(), EnumPart.SAPPHIRE.getItemStack()),
    PERIDOTPICKAXE("Peridot Pickaxe", "pickaxeperidot", ProjectRedExploration.toolMaterialPeridot(), EnumPart.PERIDOT.getItemStack()),

    RUBYSHOVEL("Ruby Shovel", "shovelruby", ProjectRedExploration.toolMaterialRuby(), EnumPart.RUBY.getItemStack()),
    SAPPHIRESHOVEL("Sapphire Shovel", "shovelsapphire", ProjectRedExploration.toolMaterialSapphire(), EnumPart.SAPPHIRE.getItemStack()),
    PERIDOTSHOVEL("Peridot Shovel", "shovelperidot", ProjectRedExploration.toolMaterialPeridot(), EnumPart.PERIDOT.getItemStack()),

    RUBYSWORD("Ruby Sword", "swordruby", ProjectRedExploration.toolMaterialRuby(), EnumPart.RUBY.getItemStack()),
    SAPPHIRESWORD("Sapphire Sword", "swordsapphire", ProjectRedExploration.toolMaterialSapphire(), EnumPart.SAPPHIRE.getItemStack()),
    PERIDOTSWORD("Peridot Sword", "swordperidot", ProjectRedExploration.toolMaterialPeridot(), EnumPart.PERIDOT.getItemStack()),

    RUBYHOE("Ruby Hoe", "hoeruby", ProjectRedExploration.toolMaterialRuby(), EnumPart.RUBY.getItemStack()),
    SAPPHIREHOE("Sapphire Hoe", "hoesapphire", ProjectRedExploration.toolMaterialSapphire(), EnumPart.SAPPHIRE.getItemStack()),
    PERIDOTHOE("Peridot Hoe", "hoeperidot", ProjectRedExploration.toolMaterialPeridot(), EnumPart.PERIDOT.getItemStack()),

    WOODSAW("Wood Saw", "sawwood", ToolMaterial.WOOD, new ItemStack(Blocks.planks)),
    STONESAW("Stone Saw", "sawstone", ToolMaterial.STONE, new ItemStack(Items.flint)),
    IRONSAW("Iron Saw", "sawiron", ToolMaterial.IRON, new ItemStack(Items.iron_ingot)),
    GOLDSAW("Gold Saw", "sawgold", ToolMaterial.GOLD, new ItemStack(Items.gold_ingot)),
    RUBYSAW("Ruby Saw", "sawruby", ProjectRedExploration.toolMaterialRuby(), EnumPart.RUBY.getItemStack()),
    SAPPHIRESAW("Sapphire Saw", "sawsapphire", ProjectRedExploration.toolMaterialSapphire(), EnumPart.SAPPHIRE.getItemStack()),
    PERIDOTSAW("Peridot Saw", "sawperidot", ProjectRedExploration.toolMaterialPeridot(), EnumPart.PERIDOT.getItemStack()),
    DIAMONDSAW("Diamond Saw", "sawdiamond", ToolMaterial.EMERALD, new ItemStack(Items.diamond)),

    WOODSICKLE("Wood Sickle", "sicklewood", ToolMaterial.WOOD, new ItemStack(Blocks.planks)),
    STONESICKLE("Stone Sickle", "sicklestone", ToolMaterial.STONE, new ItemStack(Items.flint)),
    IRONSICKLE("Iron Sickle", "sickleiron", ToolMaterial.IRON, new ItemStack(Items.iron_ingot)),
    GOLDSICKLE("Gold Sickle", "sicklegold", ToolMaterial.GOLD, new ItemStack(Items.gold_ingot)),
    RUBYSICKLE("Ruby Sickle", "sickleruby", ProjectRedExploration.toolMaterialRuby(), EnumPart.RUBY.getItemStack()),
    SAPPHIRESICKLE("Sapphire Sickle", "sicklesapphire", ProjectRedExploration.toolMaterialSapphire(), EnumPart.SAPPHIRE.getItemStack()),
    PERIDOTSICKLE("Peridot Sickle", "sickleperidot", ProjectRedExploration.toolMaterialPeridot(), EnumPart.PERIDOT.getItemStack()),
    DIAMONDSICKLE("Diamond Sickle", "sicklediamond", ToolMaterial.EMERALD, new ItemStack(Items.diamond)), ;

    public final ToolMaterial material;
    public final String name;
    public final String unlocal;

    public final ItemStack repairStack;

    private EnumSpecialTool(String name, String unlocal, ToolMaterial material, ItemStack repair)
    {
        this.name = name;
        this.unlocal = unlocal;
        this.material = material;
        this.repairStack = repair;
    }
}
