package mrtjp.projectred.exploration;

import cpw.mods.fml.common.registry.GameRegistry;
import mrtjp.projectred.ProjectRedExploration;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.item.ItemSpade;
import net.minecraft.item.ItemStack;

public class ItemGemShovel extends ItemSpade
{
    EnumSpecialTool tool;

    public ItemGemShovel(EnumSpecialTool tool)
    {
        super(tool.material);
        this.tool = tool;
        String name = "projectred.exploration." + tool.unlocal;
        this.setUnlocalizedName(name);
        this.setCreativeTab(ProjectRedExploration.tabExploration());
        GameRegistry.registerItem(this, name);
    }

    @Override
    public boolean getIsRepairable(ItemStack ist1, ItemStack ist2)
    {
        if (tool.repairStack.isItemEqual(ist2))
            return true;
        return super.getIsRepairable(ist1, ist2);
    }

    @Override
    public void registerIcons(IIconRegister reg)
    {
        this.itemIcon = reg.registerIcon("projectred:gemtools/" + tool.unlocal);
    }
}
